
#ifndef __PLINK_H__
#define __PLINK_H__

#include <vector>
#include <algorithm>
#include <iostream>

#include <iostream>
#include <iomanip>
#include <fstream>
#include <sstream>
#include <cmath>
#include <algorithm>
#include <cerrno>
#include <cstdio>
#include <ctime>
#include "helper.h"

#include "../br2.h"

using namespace std;

class Plink
{
public:
    int locus;
    int persons;

	void fullModelAssoc(
			bool print_results,
			vector<Individual*>  &sample,
			 vector<Locus*> &locus,
			 vector<ModelOutput> &out
	);

	void testQAssoc(bool print_results,
	    vector<Individual*> &Sample, vector<Locus*> &SNPs,
	    vector <LogisticOutput> &results);

	void testAssoc(vector<Individual*> &sample, vector<Locus*> &SNP,
	    vector<LogisticOutput> &out);
};


namespace par {

	extern  int min_geno_cell;
	extern  string output_file_name;
	extern  int pp_maxsnp;
	extern  int fisher_test;
	extern  int adaptive_perm;

	extern  int model_perm_best;
	extern  int model_perm_gen;
	extern  int model_perm_dom;
	extern  int model_perm_rec;
	extern  int model_perm_trend;
	extern  int verbose;


	const bool return_beta = false;
	const int ci_zt = 1;
	const bool display_ci = false;
};




inline
void printLOG(string s)
{
  cout << s;
}


inline
void error(string msg)
{
  cout << "\nERROR: " << msg << "\n";

  exit(1);
}


#endif
